codeforces 672D D. Robin Hood (二分+思维)

42 篇文章 0 订阅
24 篇文章 0 订阅

D. Robin Hood

time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

We all know the impressive story of Robin Hood. Robin Hood uses his archery skills and his wits to steal the money from rich, and return it to the poor.

There are n citizens in Kekoland, each person has ci coins. Each day, Robin Hood will take exactly 1 coin from the richest person in the city and he will give it to the poorest person (poorest person right after taking richest's 1 coin). In case the choice is not unique, he will select one among them at random. Sadly, Robin Hood is old and want to retire in k days. He decided to spend these last days with helping poor people.

After taking his money are taken by Robin Hood richest person may become poorest person as well, and it might even happen that Robin Hood will give his money back. For example if all people have same number of coins, then next day they will have same number of coins too.

Your task is to find the difference between richest and poorest persons wealth after k days. Note that the choosing at random among richest and poorest doesn't affect the answer.

 
Input

The first line of the input contains two integers n and k (1 ≤ n ≤ 500 000, 0 ≤ k ≤ 109) — the number of citizens in Kekoland and the number of days left till Robin Hood's retirement.

The second line contains n integers, the i-th of them is ci (1 ≤ ci ≤ 109) — initial wealth of the i-th person.

 
Output

Print a single line containing the difference between richest and poorest peoples wealth.

 
Examples
input
4 1
1 1 4 2
output
2
input
3 1
2 2 2
output
0
Note

Lets look at how wealth changes through day in the first sample.

  1. [1, 1, 4, 2]
  2. [2, 1, 3, 2] or [1, 2, 3, 2]

So the answer is 3 - 1 = 2

In second sample wealth will remain the same for each person.


题目大意:

给你N个人的财富值,每天最有钱的人会给最没钱的人一块钱,问K天之后,最穷的人和最富有的人之间差多少钱。


思路:


1、一直在想二分差值,然后发现最小值和最大值的问题不是很好处理,一直在想一个科学的连续二分的方式去枚举出最小值和最大值。以一种二分套二分的方式去解,以失败告终。


2、正解是这样的:

首先得明确一点,初始时硬币数比平均数少的人最终会增加k个硬币,比平均数多的会减少k个硬币,
所以根据这个先用二分求出最终最少的硬币数,然后最用二分求出最终最多的硬币数,然后相减就行了,明确这一点这题目差不多就出来了。。。

①因为时间越长(天数经过的越多),最大值就会越小,同理,最小值就会越大(所以这就是智障的去二分差值的理由?尼玛本质是最大值最小值的变化好嘛,为毛要想到差值上去.......)那么我们二分一个最小值,接下来二分一个最大值。

②判定二分的过程很简单,对于枚举最小值的时候,如果需要的最少天数小于等于k,那么就加大最小值,否则减小最小值即可。那么二分枚举最大值的时候同理即可。

③问题的坑点在于维护上下界。对于总值:sum,如果sum%n==0,那么最小值的上界就是sum/n,最大值的下界也是sum/n.当sum%n!=0的时候,最小值的上界还是sum/n,但是最大值的下界应该是sum/n+1.这里被坑了......................


这个从最大的拿东西给最小的,不是枚举差值。。


#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <algorithm>
using namespace std;
const int maxn = 5e5 + 5;
typedef long long ll;
ll a[maxn], n, k;
int check(ll x)   //判断以这个x为最小的天数,需要多少天
{
    ll res = 0;
    for(int i = 1; i <= n; i++)
    {
        if(a[i] < x) res += x-a[i]; //比他小, 就说明这些都要得到1,最终达到最小的天
    }
    return res <= k;
}
int check2(ll x)
{
    ll res = 0;
    for(int i = 1; i <= n; i++)
    {
        if(a[i] > x) res += a[i]-x;  //比他大, 就往外给,最终到达最大的天
    }
    return res <= k;
}
int main()
{
    scanf("%lld%lld", &n, &k);
    ll sum = 0;
    for(int i = 1; i <= n; i++)
    {
        scanf("%lld", &a[i]);
        sum += a[i];
    }
    ll limit = sum / n;
    ll limit2 = limit;
    if(sum%n) limit2++;
    ll ansx = 0, ansy = 0;
    ll l = 1, r = limit, mid;
    while(l <= r)
    {
        mid = (l+r)/2;
        if(check(mid))
        {
            ansx = mid;
            l = mid + 1;
        }
        else
            r = mid - 1;
    }
    l = limit2;
    r = sum;
    while(l <= r)
    {
        mid = (l+r)/2;
        if(check2(mid))
        {
            ansy = mid;
            r = mid - 1;
        }
        else
            l = mid + 1;
    }
    printf("%lld\n", ansy-ansx);
    return 0;
}



  • 4
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
Codeforces Round 894 (Div. 3) 是一个Codeforces举办的比赛,是第894轮的Div. 3级别比赛。它包含了一系列题目,其中包括题目E. Kolya and Movie Theatre。 根据题目描述,E. Kolya and Movie Theatre问题要求我们给定两个字符串,通过三种操作来让字符串a等于字符串b。这三种操作分别为:交换a中相同位置的字符、交换a中对称位置的字符、交换b中对称位置的字符。我们需要先进行一次预处理,替换a中的字符,然后进行上述三种操作,最终得到a等于b的结果。我们需要计算预处理操作的次数。 根据引用的讨论,当且仅当b[i]==b[n-i-1]时,如果a[i]!=a[n-i-1],需要进行一次操作;否则不需要操作。所以我们可以遍历字符串b的前半部分,判断对应位置的字符是否与后半部分对称,并统计需要进行操作的次数。 以上就是Codeforces Round 894 (Div. 3)的简要说明和题目E. Kolya and Movie Theatre的要求。<span class="em">1</span><span class="em">2</span><span class="em">3</span> #### 引用[.reference_title] - *1* *2* [Codeforces Round #498 (Div. 3) (A+B+C+D+E+F)](https://blog.csdn.net/qq_46030630/article/details/108804114)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v93^chatsearchT3_2"}}] [.reference_item style="max-width: 50%"] - *3* [Codeforces Round 894 (Div. 3)A~E题解](https://blog.csdn.net/gyeolhada/article/details/132491891)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v93^chatsearchT3_2"}}] [.reference_item style="max-width: 50%"] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值